Bug 147969 - msync(..., ..., MS_SYNC) returning before data written to disk
Summary: msync(..., ..., MS_SYNC) returning before data written to disk
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: kernel   
(Show other bugs)
Version: 3.0
Hardware: i686
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Larry Woodman
QA Contact: Brian Brock
URL:
Whiteboard:
Keywords: Regression
Depends On:
Blocks: 132991
TreeView+ depends on / blocked
 
Reported: 2005-02-14 09:33 UTC by Chris Richards
Modified: 2018-10-27 13:04 UTC (History)
11 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-04-22 20:17:34 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2005:293 high SHIPPED_LIVE Important: kernel security update 2005-04-22 04:00:00 UTC
Red Hat Product Errata RHSA-2005:294 normal SHIPPED_LIVE Moderate: Updated kernel packages available for Red Hat Enterprise Linux 3 Update 5 2005-05-18 04:00:00 UTC

Description Chris Richards 2005-02-14 09:33:45 UTC
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (compatible; Konqueror/3.2) (KHTML, like Gecko)

Description of problem:
Calling msync(p, size, MS_SYNC) on a memory mapped file is not waiting for the data to be flushed to disk [eg a 128Mb chunk of data is claiming to be flushed in 1-2ms : cf 2.4.21-15 / 2.6.8-1.521 where the same test code takes 2-3s to do this]

This means that there is no way for code to know that the data it has just written to a memory mapped file has actually made it to disk.

Version-Release number of selected component (if applicable):
kernel-2.4.21-20.EL and kernel-2.4.21-27.0.2.EL

How reproducible:
Always

Steps to Reproduce:
1.mmap a (large-ish) file
2.write some data into the memory region
3.call msync with the MS_SYNC option
4.reboot the PC by hitting the power switch once msync has completed... [or time how long it takes to sync the data]
5.look at the contents of the file
    

Actual Results:  Data missing from file on disk (was present in file (ie disk buffers) prior to hitting power)

Expected Results:  msync should wait for the data to be written to disk when the MS_SYNC flag is used.

Additional info:

Comment 2 Chris Richards 2005-02-16 17:41:03 UTC
linux-2.4.21-mmap-updates.patch lines 193/4 seem to be the problem.  
Upper limit test on end >= vma->vm_end fails when you sync the whole 
memory mapped area, but returns error (==0 ==success) so that you 
have no idea that it hasn't sync'ed anything at all. 

Comment 7 Larry Woodman 2005-02-17 14:20:14 UTC
The patch to fix this problem was sent to rhkernel-list and has recieved the
nexessary ACKs for inclusion in RHEL3-U5.

Larry Woodman


Comment 8 Ernie Petrides 2005-02-19 10:23:21 UTC
A fix for this problem has just been committed to the RHEL3 U5
patch pool this evening (in kernel version 2.4.21-27.16.EL).


Comment 9 Ernie Petrides 2005-04-16 22:31:45 UTC
A fix for this problem has also been committed to the RHEL3 E5
patch pool this afternoon (in kernel version 2.4.21-27.0.4.EL).


Comment 10 Josh Bressers 2005-04-22 20:17:35 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2005-293.html


Comment 11 Tim Powers 2005-05-18 13:29:17 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2005-294.html



Note You need to log in before you can comment on or make changes to this bug.